#!/usr/bin/python2.7
# coding=UTF-8
import sys
import re
import gtk
from cracklib import VeryFascistCheck

def password_problems(p1, p2):
    if len(p1) < 8:
        return 'Password is too short'
    try:
        VeryFascistCheck(p1)
    except ValueError as err:
        return str(err)
    if p2 == "":
        return 'Password is acceptable'
    if p1 != p2:
        return 'Passwords do not match'
    return None


class NewPassword:

    def __init__(self, username="",
                       fullname="",
                       email="",
                       title="Verify your details",
                       label="Your local user account",
                       passchar="☢",
                       width=320, height=158):
        self.Password = ''

        screen_width = gtk.gdk.screen_width()
        screen_height = gtk.gdk.screen_height()

        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.window.connect("delete_event", self.Cancel)
        self.window.set_title(title)
        self.window.move((screen_width - width)/2, (screen_height - height)/2)
        self.window.resize(width, height)

        self.namelabel = gtk.Label("Full name:")
        self.namelabel.set_justify(gtk.JUSTIFY_RIGHT)
        self.namelabel.set_alignment(1.0, 0.5)

        self.nameentry = gtk.Label(fullname)
        self.nameentry.set_justify(gtk.JUSTIFY_LEFT)
        self.nameentry.set_alignment(0.0, 0.5)

        self.userlabel = gtk.Label("Username:")
        self.userlabel.set_justify(gtk.JUSTIFY_RIGHT)
        self.userlabel.set_alignment(1.0, 0.5)

        self.userentry = gtk.Label(username)
	self.userentry.set_justify(gtk.JUSTIFY_LEFT)
        self.userentry.set_alignment(0.0, 0.5)

        self.pass1label = gtk.Label("Password:")
        self.pass1label.set_justify(gtk.JUSTIFY_RIGHT)
        self.pass1label.set_alignment(1.0, 0.5)

        self.pass1entry = gtk.Entry(0)
        self.pass1entry.set_invisible_char(passchar)
        self.pass1entry.set_visibility(False)
        self.pass1entry.connect("changed", self.changed)

        self.pass2label = gtk.Label("Verify password:")
        self.pass2label.set_justify(gtk.JUSTIFY_RIGHT)
        self.pass2label.set_alignment(1.0, 0.5)

        self.pass2entry = gtk.Entry(0)
        self.pass2entry.set_invisible_char(passchar)
        self.pass2entry.set_visibility(False)
        self.pass2entry.connect("changed", self.changed)
        self.pass2entry.connect("activate", self.trycreate)

	self.infolabel = gtk.Label("")
	self.infolabel.set_justify(gtk.JUSTIFY_LEFT)
	self.infolabel.set_alignment(0.0, 0.5)	

        self.createbutton = gtk.Button("   Create   ")
        self.createbutton.connect("clicked", self.Create)
        self.createbutton.set_sensitive(False)

        self.cancelbutton = gtk.Button("   Cancel   ")
        self.cancelbutton.connect("clicked", self.Cancel)
	self.cancelbutton.set_sensitive(True)

        table = gtk.Table(rows=4, columns=2, homogeneous=False)
        table.attach(self.namelabel,  0, 1, 0, 1, xoptions=gtk.EXPAND|gtk.FILL, yoptions=gtk.EXPAND, xpadding=4, ypadding=2)
        table.attach(self.nameentry,  1, 2, 0, 1, xoptions=gtk.EXPAND|gtk.FILL, yoptions=gtk.EXPAND, xpadding=4, ypadding=2)
        table.attach(self.userlabel,  0, 1, 1, 2, xoptions=gtk.EXPAND|gtk.FILL, yoptions=gtk.EXPAND, xpadding=4, ypadding=2)
        table.attach(self.userentry,  1, 2, 1, 2, xoptions=gtk.EXPAND|gtk.FILL, yoptions=gtk.EXPAND, xpadding=4, ypadding=2)

        table.attach(self.pass1label, 0, 1, 2, 3, xoptions=gtk.EXPAND|gtk.FILL, yoptions=gtk.EXPAND, xpadding=4, ypadding=2)
        table.attach(self.pass1entry, 1, 2, 2, 3, xoptions=gtk.EXPAND|gtk.FILL, yoptions=gtk.EXPAND, xpadding=4, ypadding=2)
        table.attach(self.pass2label, 0, 1, 3, 4, xoptions=gtk.EXPAND|gtk.FILL, yoptions=gtk.EXPAND, xpadding=4, ypadding=2)
        table.attach(self.pass2entry, 1, 2, 3, 4, xoptions=gtk.EXPAND|gtk.FILL, yoptions=gtk.EXPAND, xpadding=4, ypadding=2)
	table.attach(self.infolabel,  1, 2, 4, 5, xoptions=gtk.EXPAND|gtk.FILL, yoptions=gtk.EXPAND, xpadding=4, ypadding=2)

        frame = gtk.Frame(label)
        frame.add(table)

        hbox = gtk.HBox(homogeneous=True, spacing=2)
        hbox.add_with_properties(self.cancelbutton, "fill", False, "expand", True)
        hbox.add_with_properties(self.createbutton, "fill", False, "expand", True)
        hbox.set_focus_chain([self.createbutton, self.cancelbutton])

        empty = gtk.HBox(spacing=4)

        vbox = gtk.VBox(homogeneous=False, spacing=2)
        vbox.add_with_properties(frame, "fill", True, "expand", False)
        vbox.add_with_properties(hbox, "fill", False, "expand", False)
        vbox.add_with_properties(empty, "fill", True, "expand", True)

        self.window.add(vbox)
        self.window.show_all()

    def changed(self, *args):
        problems = password_problems(self.pass1entry.get_text(), self.pass2entry.get_text())
        self.createbutton.set_sensitive(problems is None)
        if problems is None:
            self.infolabel.set_text("Acceptable")
        else:
            self.infolabel.set_text(problems)

    def trycreate(self, *args):
        if password_problems(self.pass1entry.get_text(), self.pass2entry.get_text()) is None:
            self.createbutton.set_sensitive(True)
            self.Create(*args)

    def Cancel(self, *args):
        self.Username = ''
        self.Password = ''
        gtk.main_quit()
	return False

    def Create(self, *args):
        p = self.pass1entry.get_text()
	if password_problems(p, self.pass2entry.get_text()) is None:
            self.Password = p
            gtk.main_quit()

if __name__ == '__main__':

    if len(sys.argv) < 3:
        sys.exit(1)

    window = NewPassword(username=sys.argv[1], fullname=sys.argv[2], email=sys.argv[3])
    gtk.main()

    sys.stdout.write(str(window.Password))
    sys.stdout.write("\n")
